@echo off

rem  Description: A set of tools to convert expanded folders into esd-files based on
rem				  created ActionList.xml file during Windows 10 UUP upgrade so that
rem				  already existing UUPtoISO tools can create a setup media file
rem				  without errors.
rem Dependencies: .NET Framework 4.5.2, XMLParser.exe, wimlib-imagex.exe
rem Designed for: UUPtoISO
rem		  Script: @slicendice
rem    XMLParser: @slicendice
rem		  Thanks: Tenforums and everybody who has contributed to UUPtoISO (you know who you are)
rem      License: XMLParser.exe and ActionListParser.cmd are absolutely free to use, redistribute
rem				  and decompile, so do whatever you like with them. For all other related
rem				  components and their licenses, please check with their respective owners.

call :set_variables

title %windowTitle%

cls
if not exist "%~dp0bin\XMLParser.exe" echo %errParserMissing% && goto :eof
if not exist "%~dp0UUPs\ActionList.xml" echo %errActionListMissing% && goto :eof
if exist "%~dp0ActionList.cmd" del "%~dp0ActionList.cmd"

set "XMLParser=%~dp0bin\XMLParser.exe"

call :create_job
rem goto :eof

call :execute_job

echo.
pause

goto :eof

:set_variables
set "windowTitle=ActionList processor by SlicEnDicE Software"
set "errParserMissing=ERROR: Could not find required application XMLParser.exe"
set "errActionListMissing=ERROR: Could not find the ActionList.xml file to process"
set "errJobFileMissing=ERROR: Missing ActionList.cmd"
set "jobCreateCommandList=Creating command list for packages to convert to ESD"
set "jobExecuteConversion=Start executing package conversion"
set "jobRemoveOldActionList=Removed old ActionList.cmd"
set "jobCommandListCreated=Successfully created CommandList.cmd"
exit /b

:create_job
if exist "%~dp0\ActionList.cmd" del "%~dp0\ActionList.cmd" && echo %jobRemoveOldActionList%
echo %jobCreateCommandList%
"%XMLParser%" "%~dp0UUPs" > ActionList.cmd
echo %jobCommandListCreated%
exit /b

:execute_job
if not exist "%~dp0\ActionList.cmd" echo %errJobFileMissing% && exit /b
echo %jobExecuteConversion%
call "%~dp0\ActionList.cmd"
del "%~dp0ActionList.cmd"
exit /b

:exit_application
exit /b
